/*@lineinfo:filename=FundamentalExample6*//*@lineinfo:user-code*//*@lineinfo:1^1*//*
   The program FundamentalExample6.sqlj illustrates the use of PL/SQL
   in SQLJ. This program illustrates the use of the following:
   - PL/SQL procedure calls
   - PL/SQL function calls
   - SET statement
   - embedding blocks of anonymous PL/SQL
   - PL/SQL REF CURSORs
*/

// import required packages
import java.sql.*;
import oracle.sqlj.runtime.Oracle;

public class FundamentalExample6 {

  /*@lineinfo:generated-code*//*@lineinfo:17^3*/

//  ************************************************************
//  SQLJ iterator declaration:
//  ************************************************************

public static class CustomerIteratorClass 
extends sqlj.runtime.ref.ResultSetIterImpl
implements sqlj.runtime.NamedIterator
{
  public CustomerIteratorClass(sqlj.runtime.profile.RTResultSet resultSet) 
    throws java.sql.SQLException 
  {
    super(resultSet);
    idNdx = findColumn("id");
    first_nameNdx = findColumn("first_name");
    last_nameNdx = findColumn("last_name");
    dobNdx = findColumn("dob");
    phoneNdx = findColumn("phone");
  }
  public int id() 
    throws java.sql.SQLException 
  {
    return resultSet.getIntNoNull(idNdx);
  }
  private int idNdx;
  public String first_name() 
    throws java.sql.SQLException 
  {
    return resultSet.getString(first_nameNdx);
  }
  private int first_nameNdx;
  public String last_name() 
    throws java.sql.SQLException 
  {
    return resultSet.getString(last_nameNdx);
  }
  private int last_nameNdx;
  public Date dob() 
    throws java.sql.SQLException 
  {
    return resultSet.getDate(dobNdx);
  }
  private int dobNdx;
  public String phone() 
    throws java.sql.SQLException 
  {
    return resultSet.getString(phoneNdx);
  }
  private int phoneNdx;
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:23^3*/

  public static void main(String [] args) throws SQLException {

    try {

      Oracle.connect(
        "jdbc:oracle:thin:@localhost:1521:orcl",
        "fundamental_user",
        "fundamental_password"
      );

      // PL/SQL procedure calls
      System.out.println("PL/SQL procedure calls.");

      // display the price of product 1
      displayPrice(1);

      System.out.println("Reducing the price of product 1 by 10% " +
        "using the PL/SQL procedure update_product_price().");
      /*@lineinfo:generated-code*//*@lineinfo:43^7*/

//  ************************************************************
//  #sql { CALL update_product_price(1, .9)  };
//  ************************************************************

{
  sqlj.runtime.ConnectionContext __sJT_connCtx = sqlj.runtime.ref.DefaultContext.getDefaultContext();
  if (__sJT_connCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext __sJT_execCtx = __sJT_connCtx.getExecutionContext();
  if (__sJT_execCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_EXEC_CTX();
  synchronized (__sJT_execCtx) {
    sqlj.runtime.profile.RTStatement __sJT_stmt = __sJT_execCtx.registerStatement(__sJT_connCtx, FundamentalExample6_SJProfileKeys.getKey(0), 0);
    try 
    {
      __sJT_execCtx.execute();
    }
    finally 
    {
      __sJT_execCtx.releaseStatement();
    }
  }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:43^47*/

      displayPrice(1);

      // PL/SQL function calls
      System.out.println("\nPL/SQL function calls.");
      int result;

      System.out.println("Doubling the price of product 1 using the " +
        "PL/SQL function update_product_price_func().");
      /*@lineinfo:generated-code*//*@lineinfo:53^7*/

//  ************************************************************
//  #sql result = { VALUES(update_product_price_func(1, 2))  };
//  ************************************************************

{
  sqlj.runtime.ConnectionContext __sJT_connCtx = sqlj.runtime.ref.DefaultContext.getDefaultContext();
  if (__sJT_connCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext __sJT_execCtx = __sJT_connCtx.getExecutionContext();
  if (__sJT_execCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_EXEC_CTX();
  synchronized (__sJT_execCtx) {
    sqlj.runtime.profile.RTStatement __sJT_stmt = __sJT_execCtx.registerStatement(__sJT_connCtx, FundamentalExample6_SJProfileKeys.getKey(0), 1);
    try 
    {
      __sJT_execCtx.executeUpdate();
      int __sJT_result;
      __sJT_result = __sJT_stmt.getIntNoNull(1);
      result = __sJT_result;
    }
    finally 
    {
      __sJT_execCtx.releaseStatement();
    }
  }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:53^63*/

      System.out.println("The result returned from " +
        "update_product_price_func() was " + result + ".");
      System.out.println("A result of 0 indicates success " +
        "(1 indicates failure to find part).");

      displayPrice(1);

      // SET statement
      System.out.println("\nSET statement.");

      System.out.println("Halving the price of product 1 using " +
        "update_product_price_func().");
      /*@lineinfo:generated-code*//*@lineinfo:67^7*/

//  ************************************************************
//  #sql { SET :result = update_product_price_func(1, .5)  };
//  ************************************************************

{
  sqlj.runtime.ConnectionContext __sJT_connCtx = sqlj.runtime.ref.DefaultContext.getDefaultContext();
  if (__sJT_connCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext __sJT_execCtx = __sJT_connCtx.getExecutionContext();
  if (__sJT_execCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_EXEC_CTX();
  synchronized (__sJT_execCtx) {
    sqlj.runtime.profile.RTStatement __sJT_stmt = __sJT_execCtx.registerStatement(__sJT_connCtx, FundamentalExample6_SJProfileKeys.getKey(0), 2);
    try 
    {
      __sJT_execCtx.executeUpdate();
      result = __sJT_stmt.getIntNoNull(1);
    }
    finally 
    {
      __sJT_execCtx.releaseStatement();
    }
  }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:67^61*/

      System.out.println("The result returned " +
        "from update_product_price_func() was " + result + ".");

      displayPrice(1);

      // anonymous PL/SQL blocks
      System.out.println("\nAnonymous PL/SQL blocks.");
      System.out.println("Adding rows to the customers table.");
      /*@lineinfo:generated-code*//*@lineinfo:77^7*/

//  ************************************************************
//  #sql { DECLARE
//            l_count INT;
//          BEGIN
//  
//            -- insert three test customers into the customers table
//            FOR l_count IN 10 .. 12 LOOP
//              INSERT INTO
//                customers (id, first_name, last_name, dob, phone)
//              VALUES
//                (l_count, 'Test', 'Test', '01-JAN-2000', '650-555-1212');
//            END LOOP;
//  
//            COMMIT;
//          END;
//         };
//  ************************************************************

{
  sqlj.runtime.ConnectionContext __sJT_connCtx = sqlj.runtime.ref.DefaultContext.getDefaultContext();
  if (__sJT_connCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext __sJT_execCtx = __sJT_connCtx.getExecutionContext();
  if (__sJT_execCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_EXEC_CTX();
  synchronized (__sJT_execCtx) {
    sqlj.runtime.profile.RTStatement __sJT_stmt = __sJT_execCtx.registerStatement(__sJT_connCtx, FundamentalExample6_SJProfileKeys.getKey(0), 3);
    try 
    {
      __sJT_execCtx.executeUpdate();
    }
    finally 
    {
      __sJT_execCtx.releaseStatement();
    }
  }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:92^7*/

      // PL/SQL REF CURSORs
      System.out.println("\nPL/SQL REF CURSORs.");
      
      // call the function get_customers_ref_cursor() and
      // set the customer_iterator to the REF CURSOR returned
      // by the function
      CustomerIteratorClass customer_iterator;
      /*@lineinfo:generated-code*//*@lineinfo:101^7*/

//  ************************************************************
//  #sql customer_iterator = { VALUES(ref_cursor_package.get_customers_ref_cursor)
//         };
//  ************************************************************

{
  sqlj.runtime.ConnectionContext __sJT_connCtx = sqlj.runtime.ref.DefaultContext.getDefaultContext();
  if (__sJT_connCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext __sJT_execCtx = __sJT_connCtx.getExecutionContext();
  if (__sJT_execCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_EXEC_CTX();
  synchronized (__sJT_execCtx) {
    sqlj.runtime.profile.RTStatement __sJT_stmt = __sJT_execCtx.registerStatement(__sJT_connCtx, FundamentalExample6_SJProfileKeys.getKey(0), 4);
    try 
    {
      __sJT_execCtx.executeUpdate();
      CustomerIteratorClass __sJT_result;
      __sJT_result = ((CustomerIteratorClass)(__sJT_stmt.getObject(1, CustomerIteratorClass.class)));
      customer_iterator = __sJT_result;
    }
    finally 
    {
      __sJT_execCtx.releaseStatement();
    }
  }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:103^7*/

      // process the iterator
      System.out.println("Customers from REF CURSOR:");
      while (customer_iterator.next()) {
        System.out.println("id = " + customer_iterator.id());
        System.out.println("first name = " +
          customer_iterator.first_name());
        System.out.println("last name = " + customer_iterator.last_name());
        System.out.println("dob = " + customer_iterator.dob());
        System.out.println("phone = " + customer_iterator.phone());
      }

      // close the iterator
      customer_iterator.close();

      Oracle.close();

    } catch ( SQLException e ) {

      System.err.println("SQLException " + e);
      System.exit(1);

    }

  } // end of run()


  // displayPrice() displays the price of the specified product
  private static void displayPrice(

    int product_id

  ) {

    double price = 0.0;

    try {

      /*@lineinfo:generated-code*//*@lineinfo:142^7*/

//  ************************************************************
//  #sql { SELECT price  FROM products WHERE id = :product_id
//         };
//  ************************************************************

{
  sqlj.runtime.profile.RTResultSet __sJT_rtRs;
  sqlj.runtime.ConnectionContext __sJT_connCtx = sqlj.runtime.ref.DefaultContext.getDefaultContext();
  if (__sJT_connCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext __sJT_execCtx = __sJT_connCtx.getExecutionContext();
  if (__sJT_execCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_EXEC_CTX();
  int __sJT_1 = product_id;
  synchronized (__sJT_execCtx) {
    sqlj.runtime.profile.RTStatement __sJT_stmt = __sJT_execCtx.registerStatement(__sJT_connCtx, FundamentalExample6_SJProfileKeys.getKey(0), 5);
    try 
    {
      __sJT_stmt.setInt(1, __sJT_1);
      sqlj.runtime.profile.RTResultSet __sJT_result = __sJT_execCtx.executeQuery();
      __sJT_rtRs = __sJT_result;
    }
    finally 
    {
      __sJT_execCtx.releaseStatement();
    }
  }
  try 
  {
    sqlj.runtime.ref.ResultSetIterImpl.checkColumns(__sJT_rtRs, 1);
    if (!__sJT_rtRs.next())
    {
      sqlj.runtime.error.RuntimeRefErrors.raise_NO_ROW_SELECT_INTO();
    }
    price = __sJT_rtRs.getDoubleNoNull(1);
    if (__sJT_rtRs.next())
    {
      sqlj.runtime.error.RuntimeRefErrors.raise_MULTI_ROW_SELECT_INTO();
    }
  }
  finally 
  {
    __sJT_rtRs.close();
  }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:144^7*/

    } catch (SQLException e) {

      System.err.println("SQLException " + e);
      System.exit(1);

    }

    System.out.println("Price of product " + product_id + " is " + price);

  } // end of displayPrice()

}/*@lineinfo:generated-code*/class FundamentalExample6_SJProfileKeys 
{
  private static FundamentalExample6_SJProfileKeys inst = null;
  public static java.lang.Object getKey(int keyNum) 
    throws java.sql.SQLException 
  {
    if (inst == null)
    {
      inst = new FundamentalExample6_SJProfileKeys();
    }
    return inst.keys[keyNum];
  }
  private final sqlj.runtime.profile.Loader loader = sqlj.runtime.RuntimeContext.getRuntime().getLoaderForClass(getClass());
  private java.lang.Object[] keys;
  private FundamentalExample6_SJProfileKeys() 
    throws java.sql.SQLException 
  {
    keys = new java.lang.Object[1];
    keys[0] = sqlj.runtime.ref.DefaultContext.getProfileKey(loader, "FundamentalExample6_SJProfile0");
  }
}
