-- The SQL*Plus script explain_plan.sql displays the
-- execution plan for the specified statement id.

UNDEFINE 1;

SELECT
  DECODE(id, 0, '', LPAD(' ', 2*(level - 1)) ||
  level || '.' || position) || ' ' ||
  operation || ' ' ||
  options || ' ' ||
  object_name || ' ' ||
  object_type || ' ' ||
  DECODE(optimizer, NULL, '', 'Optimizer = ' || optimizer) || ' ' ||
  DECODE(cost, NULL, '', 'Cost = ' || position)
AS execution_plan
FROM
  plan_table
CONNECT BY PRIOR
  id = parent_id
AND
  statement_id = '&&1'
START WITH
  id = 0
AND
  statement_id = '&1';